// cb_maple.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
//#include "cb_maple.h"

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


#include <windows.h>
#include <stdio.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <maplec.h>
#include <mplshlib.h> // was missing !!
#include <mpltable.h>

/*
#ifdef __cplusplus
extern "C" {
#endif
*/

/************************************************************************
	wrapper for Maple:

	set neccessary types and 'global' variables,
	define the wrapper for the function f
	and then wrap the operation

	this is by extracting the code from the generated wrapper
************************************************************************/

MKernelVector mapleKernelVec;
typedef void *MaplePointer;
ALGEB *args;
static ALGEB Proc[1];

/* callback - f */
static FLOAT64 wrap_f( FLOAT64 a1 )
{
    ALGEB arg1;
    FLOAT64 r;
    ALGEB mr;

    /* float[8] */
    arg1 = ToMapleFloat(mapleKernelVec,(double) a1);

    mr = EvalMapleProc(mapleKernelVec,Proc[0], 1, arg1);

    r = MapleToFloat64(mapleKernelVec,mr);
    return( r );
}


/* main - MWRAP_my_operation */
ALGEB AddressOfWrapped( MKernelVector kv,	ALGEB fn_args )

{
    ALGEB *args;

    mapleKernelVec = kv;
    args = (ALGEB*) fn_args;

		long myAdr;

    Proc[0] = args[1];

		myAdr = (long)(&wrap_f);

		return( ToMapleInteger64(mapleKernelVec,myAdr) );
}
